#!/bin/bash
########################################################################################################################
# Novell Inc.
# 1800 South Novell Place
# Provo, UT 84606-6194
# Script Name:          duplicate_objectsids.sh
# Description:          This script will display duplicate objectsids.
#
# %Version:             1.0
# %Creation Date:       Jan 11 10:41:01 MST 2013
# %Created by:          Rance Burker - Novell Technical Services
# %Contact Information: If you have any comments/requests/issues, please contact Rance Burker at rance@novell.com
#######################################################################################################################

defaultnamingcontext=`/usr/bin/ldapsearch -x -b "" -s base defaultnamingcontext | grep -i 'defaultnamingcontext: ' | awk '{print $2}'`

export LDAPCONF=/etc/opt/novell/xad/openldap/ldap.conf

ldapsearch -Y EXTERNAL -LLL -Q -b "$defaultnamingcontext" -s sub "(&(objectclass=*)(objectsid=*))" cn objectsid >/tmp/objectsids.log

sids=$(grep -i objectsid:: /tmp/objectsids.log|sort |uniq -c |sort -n |grep -v ' 1 ' |awk '{print $3}')
sids2=$(echo $sids | sed -e 's/ /\\|/g')

grep -e $sids2 -B2 /tmp/objectsids.log  >/tmp/duplicateObjectsids.log

less /tmp/duplicateObjectsids.log
